/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package app;

import BluetoothJavaServer.src.edu.kufpg.bluetooth.server.*;
import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.stage.Stage;
import Vue.*;
import java.io.IOException;


import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.bluetooth.DataElement;
import javax.bluetooth.DeviceClass;
import javax.bluetooth.DiscoveryAgent;
import javax.bluetooth.DiscoveryListener;
import javax.bluetooth.LocalDevice;
import javax.bluetooth.RemoteDevice;
import javax.bluetooth.ServiceRecord;
import javax.bluetooth.UUID;
import javax.microedition.io.Connector;
import javax.microedition.io.StreamConnection;
import javax.obex.ClientSession;
import javax.obex.HeaderSet;
import javax.obex.Operation;
import javax.obex.ResponseCodes;

/**
 *
 * @author invite
 */
public class App extends Application implements DiscoveryListener {
    
    private static Object lock=new Object();
    private static ArrayList<RemoteDevice> devices;
    static DiscoveryListener listener = new App();
    final static List<ServiceRecord> serviceRecords = new ArrayList<ServiceRecord>();
    final static List<BluetoothConnection> connections = new ArrayList<BluetoothConnection>();
    
    @Override
    public void start(Stage stage) throws Exception{
        Parent root = FXMLLoader.load(getClass().getResource("/Vue/FXMLVue.fxml"));
        Scene scene = new Scene(root);
        stage.setTitle("La plante qui pleure");
        stage.setResizable(false);
        stage.setScene(scene);
        stage.show();
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        devices = new ArrayList<RemoteDevice>();
        try{
        	UUID serialPortUuid = new UUID(BluetoothServiceUuids.SERIAL_PORT.getHexValue());
    		UUID[] desiredServiceUuids = new UUID[] { serialPortUuid };
            LocalDevice localDevice = LocalDevice.getLocalDevice();
            DiscoveryAgent agent = localDevice.getDiscoveryAgent();
            RemoteDevice[] devices = agent.retrieveDevices(DiscoveryAgent.PREKNOWN);
            for(RemoteDevice d : devices) {
            	if(d.getBluetoothAddress().equals("201611073171")) {
            		System.out.println("Thingz trouve");
            		synchronized(lock) {
        				int result = agent.searchServices(null, desiredServiceUuids, d, listener);
        				if( DiscoveryListener.SERVICE_SEARCH_DEVICE_NOT_REACHABLE == result) {
        					System.out.println(" but it could not be reached");
        					continue;
        				}
        				lock.wait();
        				
        				
        				System.out.println("service records found");
        				
        				if(null != serviceRecords && serviceRecords.size() > 0) {
        					System.out.println("YA DES SERVICES");
        					for(ServiceRecord serviceRecord: serviceRecords) {
        						String connectionUrl = serviceRecord.getConnectionURL(ServiceRecord.NOAUTHENTICATE_NOENCRYPT, false); // I have no idea what these args are
        						StreamConnection connection;
        						try {
        							connection = (StreamConnection)Connector.open(connectionUrl);
        							DataInputStream inputStream = new DataInputStream(connection.openDataInputStream());
        							BluetoothConnection bluetoothConnection = new BluetoothConnection(d.getBluetoothAddress(), inputStream);
        							bluetoothConnection.setOutputStream(new DataOutputStream(connection.openOutputStream()));
        							connections.add(bluetoothConnection);
        							System.out.println("Connected to " + d.getBluetoothAddress());
        						} catch (IOException e) {
        							System.out.println("Could not connect to " + d.getBluetoothAddress() + ": " + e.getMessage());
        							e.printStackTrace();
        						}
        					}
        				}
        			}
            	}
            }
            
            if(connections.size() > 0) { // we are connected
            	System.out.println("start");
            	BluetoothThread t = new BluetoothThread(connections.get(0));
            	t.start();
            }
          } catch (Exception e) {
            e.printStackTrace();
        }
        
        launch(args);
        
    }

    


    @Override
    public void deviceDiscovered(RemoteDevice btDevice, DeviceClass arg1) {
        String name;
        try {
            name = btDevice.getFriendlyName(false);
        } catch (Exception e) {
            name = btDevice.getBluetoothAddress();
        }
        
        devices.add(btDevice);
        System.out.println("device found: " + name);
        
    }

    @Override
    public void inquiryCompleted(int arg0) {
        synchronized(lock){
            lock.notify();
        }
    }

   
    @Override
    public void serviceSearchCompleted(int arg0, int arg1) {
        synchronized (lock) {
            lock.notify();
        }
    }

    @Override
    public void servicesDiscovered(int transID, ServiceRecord[] servRecord) {
    	System.out.println("hey ! " + servRecord);
    	for(ServiceRecord s : servRecord) {
    		System.out.println("-------"+ s + "-------");
    	}
    	serviceRecords.addAll(Arrays.asList(servRecord));
    }
    
}
